package  
{
	import controller.events.*;
	import controller.commands.*;
	import view.mediators.*;
	import view.components.*;
	import model.*;
	
	import org.robotlegs.mvcs.Context;
	
	import flash.display.DisplayObjectContainer;
	
	/**
	 * Contexte de l'application Diaporama
	 * 
	 */
	public class MyAppContext extends Context 
	{
		
		private var _myClassToBeInjectedInstance : MyClassToBeInjected;
		
		public function MyAppContext( 	contextView : DisplayObjectContainer,
											autoStartup : Boolean = true ) 
		{
			super(contextView, autoStartup);
		}
		
		public function get myClassToBeInjectedInstance() : MyClassToBeInjected {
			return _myClassToBeInjectedInstance || (_myClassToBeInjectedInstance = new MyClassToBeInjected());
		}

		public function set myClassToBeInjectedInstance(value : MyClassToBeInjected) : void {
			_myClassToBeInjectedInstance = value;
		}		
		
		override protected function mapInjections() : void {
			trace('MyAppContext :: mapInjections');
			super.mapInjections();
			injector.mapValue(MyClassToBeInjected, myClassToBeInjectedInstance);
			trace('MyAppContext :: mapInjections IS OVER ');
			trace('-------------------------------------------');
		}		
		
		override public function startup() : void
		{
			trace('MyAppContext :: startup');
			// Controller
			commandMap.mapEvent( MyAppEvent.CONSTRUCT_CLASS, ConstructMyCustomClassCommand );
			
			// Model
			injector.mapSingleton(MyServiceConstructingMyCustomClass);	
			injector.mapSingleton(MyCustomClass);
			
			// View
			mediatorMap.mapView(ADummyView, ADummyViewMediator);
			
			// Startup
			trace('MyAppContext :: add myClassToBeInjectedInstance to contextView');
			contextView.addChild(myClassToBeInjectedInstance);
			trace('-------------------------------------------');
			
			trace('MyAppContext :: add ADummyView to contextView');
			contextView.addChild(new ADummyView());
			trace('-------------------------------------------');
			
			trace('MyAppContext :: startup IS OVER  ');
			trace('-------------------------------------------');			
		}
		
	}

}